package me.Demon.DemonSystemShop.Buy;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class BuyAPI {

    public static int getBuyPrice(int slot, int type) {
        FileConfiguration yml = Main.plugin.getConfig();
        if (type == 2) {
            int price = yml.getInt("BuyShop." + slot + ".price");
            return price * 27;
        }
        return yml.getInt("BuyShop." + slot + ".price");
    }

    public static int getInvAmount(Player p, ItemStack item) {
        int amount = 0;
        Inventory inv = p.getInventory();
        Material material = item.getType();
        for (int i = 0; i < 36; i++) {
            ItemStack items = inv.getItem(i);
            if (!DemonAPI.itemIsNull(items) && DemonAPI.itemIsLore(items)) {
                Material inv_type = items.getType();
                if (inv_type == material) {
                    amount = amount + items.getAmount();
                }
            }
        }
        return amount;
    }

    public static void SellItemEvent(Inventory inv, int playerAmount, ItemStack item, int sellAmount) {
        int last = playerAmount - sellAmount;
        for (int i = 0; i < 36; i++) {
            ItemStack items = inv.getItem(i);
            if (!DemonAPI.itemIsNull(items) && DemonAPI.itemIsLore(items)) {
                Material inv_type = items.getType();
                if (inv_type == item.getType()) {
                    inv.setItem(i, new ItemStack(Material.AIR));
                }
            }
        }
        if (last >= 1) {
            ItemStack newItem = new ItemStack(item.getType());
            newItem.setAmount(last);
            inv.addItem(newItem);
        }
    }

    // 获取商品收购总金额
    public static int getBuyMoney(String playName, String type) {
        FileConfiguration yml = Main.RdDataG;
        return yml.getInt("Data." + playName + "." + type);
    }

    // 增加商品收购总金额
    public static void addBuyMoney(String playName, String type, int money) {
        FileConfiguration yml = Main.RdDataG;
        int a = getBuyMoney(playName, type);
        yml.set("Data." + playName + "." + type, (a + money));
        Main.saveRdDataConfig();
    }
}
