package me.Demon.DemonSystemShop.Buy;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class BuyShop implements Listener {

    public static String invTitle = "战争领域 - 收购商店(VIP减税)";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            e.setCancelled(true);
            if ((e.getRawSlot() >= 0) && (e.getRawSlot() < e.getInventory().getSize() - 9)) {
                ItemStack item = e.getCurrentItem();
                if (!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                    if (e.getClick() == ClickType.LEFT) {
                        if (item.getType() == Material.CAKE) {
                            SellItemsEvant(p, item, 1, e.getRawSlot(), 1);
                        } else if (e.getCurrentItem().getType() == Material.EGG) {
                            SellItemsEvant(p, item, 16, e.getRawSlot(), 1);
                        } else {
                            SellItemsEvant(p, item, 64, e.getRawSlot(), 1);
                        }
                    }
                    if (e.getClick() == ClickType.RIGHT) {
                        if (item.getType() == Material.CAKE) {
                            SellItemsEvant(p, item, 27, e.getRawSlot(), 2);
                        } else if (e.getCurrentItem().getType() == Material.EGG) {
                            SellItemsEvant(p, item, 16 * 27, e.getRawSlot(), 2);
                        } else {
                            SellItemsEvant(p, item, 1728, e.getRawSlot(), 2);
                        }
                    }
                }
            }
            if (e.getRawSlot() == 49) {
                TabooMenuAPI.openMenu(p, "商城菜单", true);
            }
        }
    }

    public static void SellItemsEvant(Player p, ItemStack item, int sellAmount, int slot, int type) {
        //检测玩家是否拥有这么多的物品出售
        int PlayerAmount = BuyAPI.getInvAmount(p, item);
        if (PlayerAmount < sellAmount) {
            p.sendMessage(Main.prefix + "你没有足够的物品.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        BuyAPI.SellItemEvent(p.getInventory(), PlayerAmount, item, sellAmount);
        int price = BuyAPI.getBuyPrice(slot, type);
        double tax = 0.05;
        if (p.hasPermission("vip2.use")) {
            tax = 0.02;
        } else if (p.hasPermission("vip1.use")) {
            tax = 0.03;
        }
        price = (int) (price - (price * tax));
        double taxMoney = price * tax;
        DemonAPI.giveMoney(p, price);
        p.updateInventory();
        p.sendMessage(Main.prefix + "你获得了: §f$" + price + "金币 §6(纳税: " + new DecimalFormat("#.##").format(taxMoney) + "金币)");
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
        if (item.getType() == Material.DIAMOND) {
            if (type == 2) {
                Bukkit.getConsoleSender().sendMessage("[商店-日志] 玩家" + p.getName() + "正在出售大量钻石.");
            } else {
                Bukkit.getConsoleSender().sendMessage("[商店-日志] 玩家" + p.getName() + "正在出售钻石.");
            }
        }
        if (item.getType() == Material.DIAMOND) {
            BuyAPI.addBuyMoney(p.getName(), "DIAMOND", price);
        } else if (item.getType() == Material.CACTUS) {
            BuyAPI.addBuyMoney(p.getName(), "CACTUS", price);
        } else if (item.getType() == Material.WHEAT) {
            BuyAPI.addBuyMoney(p.getName(), "WHEAT", price);
        }
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 54, invTitle);
        for (int i = 45; i < inv.getSize(); i++) {
            inv.setItem(i, glass("§7[[§a▧▧§7]]", 7));
        }
        inv.setItem(48, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(49, BackBook("§a返回菜单"));
        inv.setItem(50, glass("§7[[§a▧▧§7]]", 15));
        FileConfiguration yml = Main.plugin.getConfig();
        if (yml.getString("BuyShop") != null) {
            for (String slot_key : yml.getConfigurationSection("BuyShop").getKeys(false)) {
                ItemStack item = yml.getItemStack("BuyShop." + slot_key + ".items");
                int price = yml.getInt("BuyShop." + slot_key + ".price");
                inv.setItem(Integer.parseInt(slot_key), shopitem(item, price));
            }
        }
        p.openInventory(inv);
    }

    public static ItemStack glass(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack BackBook(String name) {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack shopitem(ItemStack items, int money) {
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §r" + DemonAPI.getItemName(item));
        List<String> lore = new ArrayList<>();
        if (item.getType() == Material.CAKE) {
            lore.add("§a§l★§7左键出售1个 §f| §7价格: " + money + "元");
            lore.add("§a§l★§7右键出售27个 §f| §7价格: " + (money * 27) + "元");
        } else if (item.getType() == Material.EGG) {
            lore.add("§a§l★§7左键出售16个 §f| §7价格: " + money + "元");
            lore.add("§a§l★§7右键出售27组 §f| §7价格: " + (money * 27) + "元");
        } else {
            lore.add("§a§l★§7左键出售64个 §f| §7价格: " + money + "元");
            lore.add("§a§l★§7右键出售27组 §f| §7价格: " + (money * 27) + "元");
        }
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
