package me.Demon.DemonSystemShop.Buy;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class ExpShop implements Listener {

    public static String invTitle = "战争领域 - 经验出售";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            e.setCancelled(true);
            if (e.getRawSlot() == 0) {
                BuyExpLevel(p, 100, 500);
            }
            if (e.getRawSlot() == 2) {
                BuyExpLevel(p, 500, 2500);
            }
            if (e.getRawSlot() == 4) {
                BuyExpLevel(p, 2000, 10000);
            }
            if (e.getRawSlot() == 8) {
                TabooMenuAPI.openMenu(p, "商城菜单", true);
            }
        }
    }

    public void BuyExpLevel(Player p, int sell_exp, int money) {
        int exp = (int) p.getTotalExperience();
        if (exp < sell_exp) {
            p.sendMessage(Main.prefix + "你没有足够的生存经验用于出售.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        int take_exp = -sell_exp;
        p.giveExp(take_exp);
        DemonAPI.giveMoney(p, money);
        p.sendMessage(Main.prefix + "你获得了: §f$" + money + "金币");
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 9, invTitle);
        inv.setItem(0, shopitem(100, 500));
        inv.setItem(2, shopitem(500, 2500));
        inv.setItem(4, shopitem(2000, 10000));
        inv.setItem(8, BackBook("§a返回菜单"));
        p.openInventory(inv);
    }

    public static ItemStack glass(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack BackBook(String name) {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack shopitem(int exp, int money) {
        ItemStack item = new ItemStack(Material.EXP_BOTTLE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7[§c出售§7] §f生存经验");
        List<String> lore = new ArrayList<>();
        lore.add("§7§l★§7" + exp + "经验 = " + money + "元");
        lore.add("§a§l✔§7点击出售");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
