package me.Demon.DemonSystemShop.DayShop;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Main;
import me.Demon.DemonSystemShop.util.database.SqlManager;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

public class DayShopAPI {

    private final Player p;

    private String type;

    public DayShopAPI(Player p) {
        this.p = p;
        SqlManager sqlManager = Main.plugin.getSqlManager();
        String sqlType = sqlManager.getPlayerData(p);
        if (sqlType == null) {
            sqlManager.createPlayerTableData(p);
            sqlType = sqlManager.getPlayerData(p);
        }
        this.type = sqlType;
    }

    public String getType() {
        if (Main.BuyItemsMap.get(this.type) == null) {
            return "COBBLESTONE";
        }
        return this.type;
    }

    public void getDayRandomType() {
        List<String> list = new ArrayList<>(Main.BuyItemsList);
        int suijishu = (DemonAPI.getRandomInt(list.size(), 1) - 1);
        this.type = list.get(suijishu);
        Main.plugin.getSqlManager().SavePlayerData(p, type);
    }
}
