package me.Demon.DemonSystemShop.Sell;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Buy.BuyAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class MoneyShop implements Listener {
    public static String invTitle = "战争领域 - 现金兑换";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            e.setCancelled(true);
            if ((e.getRawSlot() >= 0) && (e.getRawSlot() < e.getInventory().getSize() - 9)) {
                if (e.getRawSlot() == 1) {
                    BuyMoneyPaper(p, 100, "现金券_100");
                }
                if (e.getRawSlot() == 3) {
                    BuyMoneyPaper(p, 500, "现金券_500");
                }
                if (e.getRawSlot() == 5) {
                    BuyMoneyPaper(p, 1000, "现金券_1000");
                }
                if (e.getRawSlot() == 7) {
                    BuyMoneyPaper(p, 5000, "现金券_5000");
                }
                if (e.getRawSlot() == 9) {
                    BuyMoneyPaper(p, 10000, "现金券_1W");
                }
                if (e.getRawSlot() == 11) {
                    BuyMoneyPaper(p, 50000, "现金券_5W");
                }
                if (e.getRawSlot() == 13) {
                    BuyMoneyPaper(p, 100000, "现金券_10W");
                }
                if (e.getRawSlot() == 15) {
                    BuyMoneyPaper(p, 500000, "现金券_50W");
                }
                if (e.getRawSlot() == 17) {
                    BuyMoneyPaper(p, 1000000, "现金券_100W");
                }
            }
            if (e.getRawSlot() == 31) {
                TabooMenuAPI.openMenu(p, "商城菜单", true);
            }
        }
    }

    public void BuyMoneyPaper(Player p, int money, String item_Key) {
        int price = (int) (money * 1.05);
        if (!DemonAPI.hasMoney(p, price)) {
            p.sendMessage(Main.prefix + "你需要§6" + new DecimalFormat(",###.##").format(price) + "§f金币才能操作.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        // 扣除金币
        DemonAPI.takeMoney(p, price);
        // 获取玩家购买物品
        ItemStack item = ItemKuAPI.getItems(p, item_Key, 1);
        p.getInventory().addItem(item);
        p.sendMessage(Main.prefix + "你获得了: §f" + DemonAPI.getItemName(item));
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
        if (price >= 50000) {
            BuyAPI.addBuyMoney(p.getName(), item_Key, 1);
        }
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 36, invTitle);
        for (int i = 27; i < inv.getSize(); i++) {
            inv.setItem(i, glass("§7[[§a▧▧§7]]", 7));
        }
        inv.setItem(30, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(31, BackBook("§a返回菜单"));
        inv.setItem(32, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(1, shopitem("§e现金券 §7[§6100§7]", 100));
        inv.setItem(3, shopitem("§e现金券 §7[§6500§7]", 500));
        inv.setItem(5, shopitem("§e现金券 §7[§61000§7]", 1000));
        inv.setItem(7, shopitem("§e现金券 §7[§65000§7]", 5000));

        inv.setItem(9, shopitem("§e现金券 §7[§610000§7]", 10000));
        inv.setItem(11, shopitem("§e现金券 §7[§650000§7]", 50000));
        inv.setItem(13, shopitem("§e现金券 §7[§b10W§7]", 100000));
        inv.setItem(15, shopitem("§e现金券 §7[§b50W§7]", 500000));
        inv.setItem(17, shopitem("§e现金券 §7[§b100W§7]", 1000000));
        p.openInventory(inv);
    }

    public static ItemStack glass(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack BackBook(String name) {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack shopitem(String name, int money) {
        ItemStack item = new ItemStack(Material.PAPER);
        item.setAmount(1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7[§a购买§7] §r" + name);
        List<String> lore = new ArrayList<>();
        int price = (int) (money * 1.05);
        lore.add("§7价格: " + new DecimalFormat(",###.##").format(price) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
