package me.Demon.DemonSystemShop.Sell;

import cn.hamster3.cdapi.CDTimeAPI;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class SellShop implements Listener {

    public static String invTitle = "战争领域 - 出售商店";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if(e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            e.setCancelled(true);
            if ((e.getRawSlot() >= 0) && (e.getRawSlot() < e.getInventory().getSize() - 9)) {
                ItemStack item = e.getCurrentItem();
                if(!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)){
                    FileConfiguration yml = Main.plugin.getConfig();
                    if (e.getClick() == ClickType.LEFT) {
                        int price = SellAPI.getSellPrice(e.getRawSlot());
                        ItemStack shop_item = yml.getItemStack("SellShop."+e.getRawSlot()+".items").clone();
                        SellItemEvent(p,shop_item,price,1);
                    }
                    if (e.getClick() == ClickType.RIGHT) {
                        int price = SellAPI.getSellPrice(e.getRawSlot());
                        ItemStack shop_item = yml.getItemStack("SellShop."+e.getRawSlot()+".items").clone();
                        SellItemEvent(p,shop_item,price,16);
                    }
                    if (e.getClick() == ClickType.MIDDLE) {
                        int price = SellAPI.getSellPrice(e.getRawSlot());
                        ItemStack shop_item = yml.getItemStack("SellShop."+e.getRawSlot()+".items").clone();
                        SellItemEvent(p,shop_item,price,64);
                    }
                }
            }
            if(e.getRawSlot() == 49){
                TabooMenuAPI.openMenu(p,"商城菜单",true);
            }
        }
    }

    public static void SellItemEvent(Player p,ItemStack shop_item,int price,int amount){
        if(CDTimeAPI.getCD(p.getUniqueId(),"sellshop_cd") >= 0){
            p.sendMessage(Main.prefix+"请勿频繁进行此操作.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        int new_price = price * amount;
        if(!DemonAPI.hasMoney(p,new_price)){
            p.sendMessage(Main.prefix+"你需要§6"+new DecimalFormat(",###.##").format(new_price)+"§f金币才能操作.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        CDTimeAPI.setPlayerCD(p.getUniqueId(),"sellshop_cd",1000*3);
        // 扣除金币
        DemonAPI.takeMoney(p,new_price);
        // 获取玩家购买物品
        shop_item.setAmount(amount);
        p.getInventory().addItem(shop_item);
        if(shop_item.getAmount() == 1) {
            p.sendMessage(Main.prefix + "你获得了: §f" + DemonAPI.getItemName(shop_item));
        }else{
            p.sendMessage(Main.prefix + "你获得了: §f" + DemonAPI.getItemName(shop_item)+"§7x§f"+shop_item.getAmount());
        }
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
    }

    public static void OpenGui(Player p){
        Inventory inv = Bukkit.createInventory(null,54,invTitle);
        for (int i = 45;i<inv.getSize();i++) {
            inv.setItem(i, glass("§7[[§a▧▧§7]]", 7));
        }
        inv.setItem(48, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(49, BackBook("§a返回菜单"));
        inv.setItem(50, glass("§7[[§a▧▧§7]]", 15));
        FileConfiguration yml = Main.plugin.getConfig();
        if(yml.getString("SellShop") != null) {
            for (String slot_key : yml.getConfigurationSection("SellShop").getKeys(false)) {
                ItemStack item = yml.getItemStack("SellShop." + slot_key + ".items");
                int price = yml.getInt("SellShop." + slot_key + ".price");
                inv.setItem(Integer.parseInt(slot_key), shopItems(item,price));
            }
        }
        p.openInventory(inv);
    }

    public static ItemStack glass(String name,int date){
        ItemStack item = new ItemStack(160,1,(short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }
    public static ItemStack BackBook(String name){
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack shopitem(ItemStack items,int price){
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §r"+DemonAPI.getItemName(item));
        List<String> lore = new ArrayList<>();
        lore.add("§7价格: "+new DecimalFormat(",###.##").format(price)+"金币");
        lore.add("§7数量: "+item.getAmount()+"个");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
    public static ItemStack shopItems(ItemStack items,int money){
        ItemStack item = items.clone();
        item.setAmount(1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§e§l★ §a购买物品: §r"+DemonAPI.getItemName(item));
        List<String> lore = new ArrayList<>();
        double price_2 = money*16;
        double price_3 = money*64;
        lore.add("§a§l★ §7物品单价: §6"+new DecimalFormat(",###.##").format(money)+" §7金币");
        lore.add("§a§l★ §6左键 §7支付 §6"+new DecimalFormat(",###.##").format(money)+" §7金币购买 §b1 §7个");
        lore.add("§a§l★ §6右键 §7支付 §6"+new DecimalFormat(",###.##").format(price_2)+" §7金币购买 §b16 §7个");
        lore.add("§a§l★ §6中键 §7支付 §6"+new DecimalFormat(",###.##").format(price_3)+" §7金币购买 §b64 §7个");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
