package me.Demon.DemonSystemShop.util;

import com.google.common.base.Charsets;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.Plugin;

import java.io.File;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.Objects;

public class ItemNameUtil {

    private static FileConfiguration fileConfiguration = null;

    public static void inits(Plugin plugin){
        File configFile = new File(plugin.getDataFolder(), "ItemName.yml");
        if (!configFile.exists()){
            plugin.saveResource("ItemName.yml", false);
        }
        fileConfiguration = YamlConfiguration.loadConfiguration(configFile);
        Reader defConfigStream = new InputStreamReader(plugin.getResource("ItemName.yml"), Charsets.UTF_8);
        YamlConfiguration defConfig = YamlConfiguration.loadConfiguration(defConfigStream);
        fileConfiguration.setDefaults(defConfig);
    }

    public static String getChineseName(ItemStack itemStack) {
        Material material = itemStack.getType();
        short data = itemStack.getData().getData();
        String type = material.name();
        if(data != 0){
            type = material.name()+":"+data;
        }
        if (fileConfiguration.getString(type) != null) {
            return fileConfiguration.getString(type);
        }
        return type;
    }
}
