package me.Demon.DemonSystemShop.util.database;

import me.Demon.DemonSystemShop.DayShop.DayShopAPI;
import me.Demon.DemonSystemShop.Main;
import me.Demon.DemonSystemShop.util.SqlUtil;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.sql.ResultSet;
import java.util.Date;

public class SqlManager {

    private Main plugin;

    public String table = "skyblock_dayshop";

    public SqlManager(Main plugin) {
        this.plugin = plugin;
    }

    private SqlUtil getSQL() {
        return plugin.getSqlUtil();
    }

    // 创建数据库表格格式
    public void createTable() {
        // 数据库结构组成
        // 玩家名字(VARCHAR) 出售品类型(VARCHAR) 刷新时间(VARCHAR)
        String s = "CREATE TABLE IF NOT EXISTS "+table+"(" +
                "    `name` VARCHAR(32) NOT NULL," +
                "    `type` VARCHAR(32) NOT NULL," +
                "    `date` VARCHAR(10) NOT NULL" +
                ") ENGINE = InnoDB";
        getSQL().openConnection();
        getSQL().updateSQL(s);
        getSQL().closeConnection();
    }

    // 创建玩家数据表格
    public void createPlayerTableData(Player p){
        // MySQL.update("INSERT INTO "+ table+" VALUES ('" + p.getName() + "','" + p.getUniqueId() + "','默认','默认');");
        String set = "INSERT INTO "+table+" (`name`, `type`, `date`) VALUES ('%player%', '%type%', '%updata%')";
        Date date = new Date();
        getSQL().openConnection();
        getSQL().updateSQL(set.replace("%player%", p.getName())
                .replace("%type%", String.valueOf("COBBLESTONE"))
                .replace("%updata%", date.getMonth()+"."+date.getDate()));
        getSQL().closeConnection();
        Bukkit.getConsoleSender().sendMessage("§6[系统商店] §a玩家首次数据创建完成。");
    }

    // 从数据库中获取玩家所有数据
    public String getPlayerData(Player p){
        String string = null;
        String select = "SELECT * FROM "+table+" WHERE name = '%playerName%'";
        try {
            getSQL().openConnection();
            ResultSet set = getSQL().querySQL(select.replace("%playerName%", p.getName()));
            if (set.next()) {
                String type = set.getString("type");
                String update = set.getString("date");
                Date date = new Date();
                if (update.equalsIgnoreCase(date.getMonth()+"."+date.getDate())) {
                    string = type;
                } else {
                    String updataType = Main.getDayRandomType();
                    SavePlayerData(p,updataType);
                    string = updataType;
                    Bukkit.getConsoleSender().sendMessage("§6["+ Main.pluginName+"] §f玩家<"+p.getName()+">的特价商店已刷新.");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            getSQL().closeConnection();
        }
        return string;
    }

    // 更新玩家数据
    public void SavePlayerData(Player player,String type){
        String set = "UPDATE `"+table+"` SET " +
                "`type` = '%type%'," +
                "`date` = '%updata%' WHERE `"+table+"`.`name` = '%player%'";
        getSQL().openConnection();
        Date date = new Date();
        String updata_time = date.getMonth()+"."+date.getDate();
        getSQL().updateSQL(set.replace("%player%", player.getName())
                .replace("%type%", String.valueOf(type))
                .replace("%updata%", updata_time));
        getSQL().closeConnection();
    }
}
