package me.Demon.DemonSystemShop.DayShop;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Buy.BuyAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class BuyShopPro implements Listener {

    public static String invTitle = "战争领域 - 每日特价商店(VIP减税)";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            e.setCancelled(true);
            if (e.getRawSlot() == 15) {
                TabooMenuAPI.openMenu(p, "商城菜单", true);
            }
            if (e.getRawSlot() == 13) {
                if (DemonAPI.hasPoints(p, 2)) {
                    DemonAPI.takePoints(p, 2);
                    DayShopAPI dataAPI = Main.dataAPI.get(p);
                    dataAPI.getDayRandomType();
                    String type = dataAPI.getType();
                    ItemStack item = new ItemStack(Material.valueOf(type));
                    String item_Name = DemonAPI.getItemName(item);
                    p.sendMessage(Main.prefix + "刷新成功!当前特价出售商品为: §e" + item_Name);
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
                    BuyShopPro.OpenGui(p);
                } else {
                    p.sendMessage(Main.prefix + "你需要§d2§f点券才能操作.");
                    p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
                }
            }
            if (e.getRawSlot() == 11) {
                if (e.getClick() == ClickType.LEFT) {
                    if (e.getCurrentItem().getType() == Material.CAKE) {
                        SellItemsEvant(p, e.getCurrentItem(), 1, 1);
                    } else if (e.getCurrentItem().getType() == Material.EGG) {
                        SellItemsEvant(p, e.getCurrentItem(), 16, 1);
                    } else {
                        SellItemsEvant(p, e.getCurrentItem(), 64, 1);
                    }
                }
                if (e.getClick() == ClickType.RIGHT) {
                    if (e.getCurrentItem().getType() == Material.CAKE) {
                        SellItemsEvant(p, e.getCurrentItem(), 27, 2);
                    } else if (e.getCurrentItem().getType() == Material.EGG) {
                        SellItemsEvant(p, e.getCurrentItem(), 16 * 27, 2);
                    } else {
                        SellItemsEvant(p, e.getCurrentItem(), 1728, 2);
                    }
                }
            }
        }
    }

    public static void SellItemsEvant(Player p, ItemStack item, int sellAmount, int type) {
        //检测玩家是否拥有这么多的物品出售
        int PlayerAmount = BuyAPI.getInvAmount(p, item);
        if (PlayerAmount < sellAmount) {
            p.sendMessage(Main.prefix + "你没有足够的物品.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        BuyAPI.SellItemEvent(p.getInventory(), PlayerAmount, item, sellAmount);
        String type_Name = String.valueOf(item.getType());
        int price = Main.BuyItemsMap.get(type_Name);
        if (type == 2) {
            price = price * 27;
        }
        double tax = 0.05;
        if (p.hasPermission("vip2.use")) {
            tax = 0.02;
        } else if (p.hasPermission("vip1.use")) {
            tax = 0.03;
        }
        price = (int) (price - (price * tax));
        double taxMoney = price * tax;
        DemonAPI.giveMoney(p, price);
        p.sendMessage(Main.prefix + "你获得了: §f$" + new DecimalFormat(",###.##").format(price) + "金币 §6(纳税: " + new DecimalFormat("#.##").format(taxMoney) + "金币)");
        p.updateInventory();
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
        if (item.getType() == Material.DIAMOND) {
            BuyAPI.addBuyMoney(p.getName(), "DIAMOND", price);
        } else if (item.getType() == Material.CACTUS) {
            BuyAPI.addBuyMoney(p.getName(), "CACTUS", price);
        } else if (item.getType() == Material.WHEAT) {
            BuyAPI.addBuyMoney(p.getName(), "WHEAT", price);
        }
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 27, invTitle);
        inv.setItem(0, glass("§7[§6每日特价§7]", 15));
        inv.setItem(8, glass("§7[§6每日特价§7]", 15));
        inv.setItem(9, glass("§7[§6每日特价§7]", 15));
        inv.setItem(17, glass("§7[§6每日特价§7]", 15));
        inv.setItem(18, glass("§7[§6每日特价§7]", 15));
        inv.setItem(26, glass("§7[§6每日特价§7]", 15));
        inv.setItem(13, UpdateType());
        inv.setItem(15, BackBook("§a返回菜单"));
        // 获取玩家今日特价出售的商品
        if (Main.dataAPI.get(p) == null) {
            Main.dataAPI.put(p, new DayShopAPI(p));
        }
        DayShopAPI dataAPI = Main.dataAPI.get(p);
        String type = dataAPI.getType();
        Material material = Material.valueOf(type);
        int price = Main.BuyItemsMap.get(type);
        inv.setItem(11, shopitem(material, price));
        p.openInventory(inv);
    }


    public static ItemStack glass(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack BackBook(String name) {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack UpdateType() {
        ItemStack item = new ItemStack(Material.LEVER);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§8« §a刷新商品 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§c§l★§7点击刷新今日特价商品");
        lore.add("§d§l★§7费用: §d2点券");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack shopitem(Material material, int money) {
        ItemStack item = new ItemStack(material);
        ItemMeta meta = item.getItemMeta();
        String item_Name = DemonAPI.getItemName(item);
        meta.setDisplayName("§a每日特价 §e" + item_Name);
        List<String> lore = new ArrayList<>();
        lore.add("§b今日特价§7出售品是 §7" + item_Name);
        lore.add("§7按下出售 §7" + item_Name);
        lore.add(" ");
        if (item.getType() == Material.CAKE) {
            lore.add("§a§l★§7左键出售1个 §f| §7价格: " + money + "元");
            lore.add("§a§l★§7右键出售27个 §f| §7价格: " + (money * 27) + "元");
        } else if (item.getType() == Material.EGG) {
            lore.add("§a§l★§7左键出售16个 §f| §7价格: " + money + "元");
            lore.add("§a§l★§7右键出售27组 §f| §7价格: " + (money * 27) + "元");
        } else {
            lore.add("§a§l★§7左键出售64个 §f| §7价格: " + money + "元");
            lore.add("§a§l★§7右键出售27组 §f| §7价格: " + (money * 27) + "元");
        }
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
