package me.Demon.DemonSystemShop.Minion;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class MinionShop implements Listener {

    public static String invTitle = "战争领域 - 小管家专卖店";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            e.setCancelled(true);
            if (e.getRawSlot() == 1) {
                String minion_type = "Miner";
                BuyEvent(p, minion_type, e.getCurrentItem());
            }
            if (e.getRawSlot() == 3) {
                String minion_type = "Lumberjack";
                BuyEvent(p, minion_type, e.getCurrentItem());
            }
            if (e.getRawSlot() == 5) {
                String minion_type = "Farmer";
                BuyEvent(p, minion_type, e.getCurrentItem());
            }
            if (e.getRawSlot() == 7) {
                String minion_type = "Fisher";
                BuyEvent(p, minion_type, e.getCurrentItem());
            }
            if (e.getRawSlot() == 11) {
                String minion_type = "Collector";
                BuyEvent(p, minion_type, e.getCurrentItem());
            }
            if (e.getRawSlot() == 13) {
                String minion_type = "Slayer";
                BuyEvent(p, minion_type, e.getCurrentItem());
            }
            if (e.getRawSlot() == 15) {
                String minion_type = "Feeder";
                BuyEvent(p, minion_type, e.getCurrentItem());
            }
            if (e.getRawSlot() == 31) {
                TabooMenuAPI.openMenu(p, "商城菜单", true);
            }
        }
    }

    public static void BuyEvent(Player p, String minion_type, ItemStack items) {
        int price = 100000;
        if (!DemonAPI.hasMoney(p, price)) {
            p.sendMessage(Main.prefix + "你需要§6" + new DecimalFormat(",###.##").format(price) + "§f金币才能操作.");
            p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
            return;
        }
        if (!Main.isJetsMinions) {
            p.sendMessage(Main.prefix + "您需要进入岛屿服后才能购买...");
            return;
        }
        MinionProperties minionProperties = Core.getInstance().getMinionManager().getMinionProperties(minion_type);
        if (minionProperties == null) {
            p.sendMessage(Main.prefix + "这个机器人貌似不存在,请联系管理员进行修复.");
            return;
        }
        // 扣除金币
        DemonAPI.takeMoney(p, price);
        // 给玩家发货
        Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "jetsminion give " + p.getName() + " " + minion_type + " 1");
        ItemMeta meta = items.getItemMeta();
        p.sendMessage(Main.prefix + "你获得了: §f" + meta.getDisplayName().replace("§7物品: ", ""));
        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 36, invTitle);
        for (int i = 27; i < inv.getSize(); i++) {
            inv.setItem(i, glass("§7[[§a▧▧§7]]", 7));
        }
        inv.setItem(30, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(31, BackBook("§a返回菜单"));
        inv.setItem(32, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(1, Miner());
        inv.setItem(3, Lumberjack());
        inv.setItem(5, Farmer());
        inv.setItem(7, Fisher());
        inv.setItem(11, Collector());
        inv.setItem(13, Slayer());
        inv.setItem(15, Feeder());
        p.openInventory(inv);
    }

    public static ItemStack glass(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack BackBook(String name) {
        ItemStack item = new ItemStack(Material.SHEARS);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Miner() {
        ItemStack item = new ItemStack(Material.DIAMOND_PICKAXE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §6矿工小管家");
        List<String> lore = new ArrayList<>();
        lore.add("§b§l★§f管家用途§7: ");
        lore.add("§7- §9自动破坏正前方的方块");
        lore.add("§b§l★§f升级效果§7: ");
        lore.add("§7- §9增加破坏距离");
        lore.add(" ");
        lore.add("§e§l★§7价格: §6" + new DecimalFormat(",###").format(100000) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Lumberjack() {
        ItemStack item = new ItemStack(Material.IRON_AXE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §6伐木小管家");
        List<String> lore = new ArrayList<>();
        lore.add("§b§l★§f管家用途§7: ");
        lore.add("§7- §9自动砍伐周围的原木");
        lore.add("§b§l★§f升级效果§7: ");
        lore.add("§7- §9增加砍伐范围");
        lore.add(" ");
        lore.add("§e§l★§7价格: §6" + new DecimalFormat(",###").format(100000) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Farmer() {
        ItemStack item = new ItemStack(Material.GOLD_HOE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §6种植小管家");
        List<String> lore = new ArrayList<>();
        lore.add("§b§l★§f管家用途§7: ");
        lore.add("§7- §9自动开垦和收获周围农作物");
        lore.add("§b§l★§f升级效果§7: ");
        lore.add("§7- §9增加开垦和收获作物范围");
        lore.add(" ");
        lore.add("§e§l★§7价格: §6" + new DecimalFormat(",###").format(100000) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Fisher() {
        ItemStack item = new ItemStack(Material.RAW_FISH);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §6渔夫小管家");
        List<String> lore = new ArrayList<>();
        lore.add("§b§l★§f管家用途§7: ");
        lore.add("§7- §9自动在周围水域捕鱼");
        lore.add("§b§l★§f升级效果§7: ");
        lore.add("§7- §9增加捕鱼范围");
        lore.add(" ");
        lore.add("§e§l★§7价格: §6" + new DecimalFormat(",###").format(100000) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Collector() {
        ItemStack item = new ItemStack(Material.COMPASS);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §6清道夫小管家");
        List<String> lore = new ArrayList<>();
        lore.add("§b§l★§f管家用途§7: ");
        lore.add("§7- §9自动收集周围掉落物");
        lore.add("§b§l★§f升级效果§7: ");
        lore.add("§7- §9增加收集范围");
        lore.add(" ");
        lore.add("§e§l★§7价格: §6" + new DecimalFormat(",###").format(100000) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Slayer() {
        ItemStack item = new ItemStack(Material.IRON_SWORD);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §6杀手小管家");
        List<String> lore = new ArrayList<>();
        lore.add("§b§l★§f管家用途§7: ");
        lore.add("§7- §9自动击杀周围生物");
        lore.add("§b§l★§f升级效果§7: ");
        lore.add("§7- §9增加击杀范围");
        lore.add(" ");
        lore.add("§e§l★§7价格: §6" + new DecimalFormat(",###").format(100000) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Feeder() {
        ItemStack item = new ItemStack(Material.GOLDEN_APPLE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §6充能小管家");
        List<String> lore = new ArrayList<>();
        lore.add("§b§l★§f管家用途§7: ");
        lore.add("§7- §9自动为周围其他小管家充能");
        lore.add("§b§l★§f升级效果§7: ");
        lore.add("§7- §9增加充能范围");
        lore.add(" ");
        lore.add("§e§l★§7价格: §6" + new DecimalFormat(",###").format(100000) + "金币");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack shopitem(ItemStack items, int price) {
        ItemStack item = items;
        item.setAmount(1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §r" + DemonAPI.getItemName(item));
        List<String> lore = new ArrayList<>();
        lore.add("§7价格: " + new DecimalFormat(",###.##").format(price) + "金币");
        lore.add("§7数量: 1280个(20组)");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
