package me.Demon.DemonSystemShop.Sell;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class BlockShop implements Listener {
    public static String invTitle = "战争领域 - 大量购买矿物块";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().equalsIgnoreCase(invTitle)) {
            e.setCancelled(true);
            if ((e.getRawSlot() >= 0) && (e.getRawSlot() < e.getInventory().getSize() - 9)) {
                int price = -1;
                if (e.getRawSlot() == 0) {
                    price = 576000;
                } else if (e.getRawSlot() == 1) {
                    price = 806400;
                } else if (e.getRawSlot() == 2) {
                    price = 2304000;
                } else if (e.getRawSlot() == 3) {
                    price = 3456000;
                }
                if (price <= 0) {
                    return;
                }
                if (!DemonAPI.hasMoney(p, price)) {
                    p.sendMessage(Main.prefix + "你需要§6" + new DecimalFormat(",###.##").format(price) + "§f金币才能操作.");
                    p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
                    return;
                }
                // 扣除金币
                DemonAPI.takeMoney(p, price);
                // 获取玩家购买物品
                ItemStack item = e.getCurrentItem();
                ItemStack shop_item = new ItemStack(item.getType());
                int amount = 1280;
                shop_item.setAmount(amount);
                p.getInventory().addItem(shop_item);
                p.sendMessage(Main.prefix + "你获得了: §f" + DemonAPI.getItemName(shop_item) + "§7x§f" + amount);
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
            }
            if (e.getRawSlot() == 31) {
                TabooMenuAPI.openMenu(p, "商城菜单", true);
            }
        }
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 36, invTitle);
        for (int i = 27; i < inv.getSize(); i++) {
            inv.setItem(i, glass("§7[[§a▧▧§7]]", 7));
        }
        inv.setItem(30, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(31, BackBook("§a返回菜单"));
        inv.setItem(32, glass("§7[[§a▧▧§7]]", 15));
        inv.setItem(0, shopitem(new ItemStack(Material.IRON_BLOCK), 576000));
        inv.setItem(1, shopitem(new ItemStack(Material.GOLD_BLOCK), 806400));
        inv.setItem(2, shopitem(new ItemStack(Material.DIAMOND_BLOCK), 2304000));
        inv.setItem(3, shopitem(new ItemStack(Material.EMERALD_BLOCK), 3456000));
        p.openInventory(inv);
    }

    public static ItemStack glass(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack BackBook(String name) {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack shopitem(ItemStack items, int price) {
        ItemStack item = items;
        item.setAmount(1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §r" + DemonAPI.getItemName(item));
        List<String> lore = new ArrayList<>();
        lore.add("§7价格: " + new DecimalFormat(",###.##").format(price) + "金币");
        lore.add("§7数量: 1280个(20组)");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
